package com.compomics.marc;

import com.compomics.util.experiment.biology.AminoAcidPattern;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;

/**
 *
 * @author Marc
 */
public class FileExtractor {

    public static void main(String[] args) {

        FileExtractor m = new FileExtractor();

        try {
            m.copyFirstLines(10000);
//            m.targetStringInLine(10000, "B8AZT1");
//            m.redistributeSpectra();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void copyFirstLines(int nLinesMax) throws FileNotFoundException, IOException {
        File inFile = new File("C:\\Users\\mva037\\Desktop\\test\\bug David\\T3A1_peaklist.mgf");
        File outFile = new File("C:\\Users\\mva037\\Desktop\\test\\bug David\\T3A1_peaklist_small.mgf");
        BufferedReader br = new BufferedReader(new FileReader(inFile));
        try {
            BufferedWriter bw = new BufferedWriter(new FileWriter(outFile));
            try {
                String line;
                int nLines = 0;
                while ((line = br.readLine()) != null && ++nLines < nLinesMax) {
                    bw.write(line);
                    bw.newLine();
                }
            } finally {
                bw.close();
            }
        } finally {
            br.close();
        }
    }

    public void targetStringInLine(int nLinesMax, String target) throws FileNotFoundException, IOException {
        File inFile = new File("Z:\\temp\\marc\\For Harald\\uniprot_eukaryota_canonical_16.06.2014.fasta");
        BufferedReader br = new BufferedReader(new FileReader(inFile));
        ArrayList<String> linesBefore = new ArrayList<String>(nLinesMax);
        ArrayList<String> linesAfter = new ArrayList<String>(nLinesMax);
        String targetLine = null;
        try {
            String line;
            int nLine = 0;
            long nChar = 0;
            while ((line = br.readLine()) != null) {
                nLine++;
                nChar += line.length();
                if (line.contains(target)) {
                    targetLine = line;
                    System.out.println(nLine + " " + nChar);
                } else if (targetLine == null) {
                    linesBefore.add(line);
                    if (linesBefore.size() > nLinesMax) {
                        linesBefore.remove(0);
                    }
                } else if (linesAfter.size() < nLinesMax) {
                    linesAfter.add(line);
                }
            }
            System.out.println(nLine + " " + nChar);
        } finally {
            br.close();
        }
        File outFile = new File("Z:\\temp\\marc\\For Harald\\uniprot_eukaryota_canonical_16.06.2014_small.fasta");
        BufferedWriter bw = new BufferedWriter(new FileWriter(outFile));
        for (String line : linesBefore) {
            bw.write(line);
            bw.newLine();
        }
        bw.write(targetLine);
        bw.newLine();
        for (String line : linesAfter) {
            bw.write(line);
            bw.newLine();
        }
        try {
        } finally {
            bw.close();
        }
    }

    private void redistributeSpectra() throws IOException {

        ArrayList<BufferedWriter> writers = new ArrayList<BufferedWriter>();
        HashMap<Integer, Integer> counters = new HashMap<Integer, Integer>();
        ArrayList<Integer> indexes = new ArrayList<Integer>();
        for (int i = 1; i < 8; i++) {
            File outputFile1 = new File("D:\\projects\\corps exquis\\" + i + ".mgf");
            BufferedWriter writer1 = new BufferedWriter(new FileWriter(outputFile1));
            writers.add(writer1);
            indexes.add(i - 1);
            counters.put(i - 1, 0);
        }
        ArrayList<File> inputFiles = new ArrayList<File>();
        inputFiles.add(new File("D:\\projects\\corps exquis\\PRIDE_Exp_Complete_Ac_8633.mgf"));
        inputFiles.add(new File("D:\\projects\\corps exquis\\PRIDE_Exp_Complete_Ac_9284.mgf"));
        inputFiles.add(new File("D:\\projects\\corps exquis\\PRIDE_Exp_Complete_Ac_9285.mgf"));
        for (File inputFile : inputFiles) {
            BufferedReader br = new BufferedReader(new FileReader(inputFile));
            try {
                String line;
                BufferedWriter bw = writers.get(0);
                while ((line = br.readLine()) != null) {
                    if (line.equals("BEGIN IONS")) {
                        Collections.shuffle(indexes);
                        int index = indexes.get(0);
                        bw = writers.get(index);
                        counters.put(index, counters.get(index) + 1);
                    }
                    if (line.startsWith("TITLE=")) {
                        line = "TITLE=" + counters.get(indexes.get(0));
                    }
                    bw.write(line);
                    bw.newLine();
                }
            } finally {
                br.close();
            }
        }
        for (BufferedWriter bufferedWriter : writers) {
            bufferedWriter.close();
        }
    }
}
